package com.ywt.mg.domain.models.enums;

/**
 * @author daiyihua
 */
public enum PaymentChannelEnum {
    WeChat("微信", 1),
    AliPay("支付宝", 2),
    Cash("现金", 3),
    MedicalCard("诊疗卡", 4),
    POS("pos机", 5),
    FREE("无须支付", 6),
    MedicalInsurance("医保", 7),
    ICBC("工行", 8),
    PharmacyPOS("药店pos机", 9),
    PharmacyUnion("门店聚合", 10),
    UNKNOWN("", 0);

    private final String displayName;

    private final int value;

    PaymentChannelEnum(String displayName, int value) {
        this.displayName = displayName;
        this.value = value;
    }

    public String getDisplayName() {
        return displayName;
    }

    public int getValue() {
        return value;
    }

    public static String getDisplayName(int value){
        for (PaymentChannelEnum enumValue : PaymentChannelEnum.values()) {
            if (enumValue.getValue() == value){
                return enumValue.displayName;
            }
        }
        return "";
    }

    public static int getDisplayValue(String name) {
        if (name == null || name.trim().equals("")) {
            return 0;
        }
        for (PaymentChannelEnum enumValue : PaymentChannelEnum.values()) {
            if (name.equals(enumValue.displayName)) {
                return enumValue.value;
            }
        }
        return 0;
    }

}
